#include "SPI.h"
#include "Adafruit_GFX.h"
#include "Adafruit_ILI9341.h"
#include "RTClib.h"
RTC_DS3231 rtc;

//char daysOfTheWeek[7][12] = {"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"};

#define TFT_DC 9
#define TFT_CS 10

Adafruit_ILI9341 tft = Adafruit_ILI9341(TFT_CS, TFT_DC);

bool button = 1;
char mystr[5][150];
//char mystr[1000];
char answer[20][20];
int index = 0;
int col = 0;
int a_i = -1;
int ai_col = 0;
bool an = false;
char temp;
uint8_t minutes;
uint8_t hours;
bool time_flag = false;
int count = 0;
DateTime now;
char c;
char memory[1000];

void mem() {
    int idx = 0;
    while(1) {
      while(!Serial.available()) {}
      temp = (char)Serial.read();
      memory[idx] = temp;
      //tft.print(temp);
      idx++;
      if (temp == '%') {
        break;
      }
    }
//    tft.fillScreen(ILI9341_BLACK);
//    tft.setCursor(50, 100);
//    tft.setTextSize(4);
//    minutes = now.minute();
//    hours = now.hour();
//    tft.print("Time:");
//    tft.print(hours);
//    tft.print(':');
//    tft.print(minutes);
}

void print_time(){
    now = rtc.now();
  if (time_flag == false){
    tft.fillScreen(ILI9341_BLACK);
    tft.setCursor(50, 100);

    tft.setTextSize(4);
    minutes = now.minute();
    hours = now.hour();
    time_flag = true;
    tft.print("Time:");
    tft.print(hours);
    tft.print(':');
    tft.print(minutes);
    }

  else if (hours != now.hour()|| minutes != now.minute()){
    if(now.hour() == 0 && now.minute() == 0){
      return;
      }

    else if(now.hour() == 165 && now.minute() == 165){
      return;
      }
      
     else{
       tft.fillScreen(ILI9341_BLACK);
       tft.setCursor(50, 100);
       //tft.setTextColor(ILI9341_WHITE);
       tft.setTextSize(4);
       hours = now.hour();
       minutes = now.minute();
       tft.print("Time:");
       tft.print(hours);
       tft.print(':');
       tft.print(minutes);
     }
    } 
  }


void display_func(){
  while(1) {
    int j = 0;
    for (int i = 0; i < 5; i++) {
      //Serial.println(i);
      tft.fillScreen(ILI9341_BLACK);
      tft.setCursor(0, 0);
      tft.setTextColor(ILI9341_WHITE);
      tft.setTextSize(2);
      while(1) {
        if (memory[j] == '*') {
          j++;
          tft.println("");
          break;
        }
        tft.print(memory[j]);
        j++;
      }
      tft.print("A: ");
      while(1) {
        if (memory[j] == '*') {
          j++;
          tft.println("");
          break;
        }
        tft.print(memory[j]);
        j++;
      }
      tft.print("B: ");
      while(1) {
        if (memory[j] == '*') {
          j++;
          tft.println("");
          break;
        }
        tft.print(memory[j]);
        j++;
      }
      tft.print("C: ");
      while(1) {
        if (memory[j] == '*') {
          j++;
          tft.println("");
          break;
        }
        tft.print(memory[j]);
        j++;
      }
      tft.print("D: ");
      while(1) {
        if (memory[j] == '@' || memory[j] == '%') {
          j++;
          tft.println("");
          break;
        }
        tft.print(memory[j]);
        j++;
      }
      while(1) {
        char ln = Serial.read();
        if (ln == '#') {
          break;
        }
        else if (ln == '@') {
          DateTime now = rtc.now();
          tft.fillScreen(ILI9341_BLACK);
          tft.setCursor(50, 100);
          tft.setTextSize(4);
          minutes = now.minute();
          hours = now.hour();
          time_flag = true;
          tft.print("Time:");
          tft.print(hours);
          tft.print(':');
          tft.print(minutes);
          return;
        }
      }
    }

  }
}

void setup() { 
  Serial.begin(1200);
  
//  rtc.begin();
  if (! rtc.begin()) {
    Serial.println("Couldn't find RTC");
    while (1);
  }

  if (rtc.lostPower()) {
    Serial.println("RTC lost power, lets set the time!");
    // following line sets the RTC to the date & time this sketch was compiled
    rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));
    // This line sets the RTC with an explicit date & time, for example to set
    // January 21, 2014 at 3am you would call:
    //rtc.adjust(DateTime(2019, 11, 3, 3, 0, 0));
  }

  tft.begin();

  tft.setRotation(3);
  tft.fillScreen(ILI9341_RED); 
  tft.setCursor(0, 0);
  tft.setTextColor(ILI9341_WHITE);
  tft.setTextSize(2);
  //pinMode(A1, INPUT);
}


void loop() {
  //Serial.println(analogRead(A1));
  temp = (char)Serial.read();
  if (temp == '$'){
    tft.setCursor(0, 0);
    tft.setTextSize(1);
    mem();
  }

  else if (temp == '^'){
    display_func();
   }

   else if (count % 1000000 == 0) {
    count = 0;
    print_time();
  }
  count++;
}
